# coding: utf-8

"""
    Fingerprint Pro Server API

    Fingerprint Pro Server API allows you to get information about visitors and about individual events in a server environment. It can be used for data exports, decision-making, and data analysis scenarios. Server API is intended for server-side usage, it's not intended to be used from the client side, whether it's a browser or a mobile device.   # noqa: E501

    OpenAPI spec version: 3
    Contact: support@fingerprint.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import Dict, List, Optional  # noqa: F401
from fingerprint_pro_server_api_sdk.base_model import BaseModel


class IPBlocklistDetails(BaseModel):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'email_spam': 'bool',
        'attack_source': 'bool'
    }

    attribute_map = {
        'email_spam': 'emailSpam',
        'attack_source': 'attackSource'
    }

    def __init__(self, email_spam=None, attack_source=None):  # noqa: E501
        """IPBlocklistDetails - a model defined in Swagger"""  # noqa: E501
        self._email_spam = None
        self._attack_source = None
        self.discriminator = None
        self.email_spam = email_spam
        self.attack_source = attack_source

    @property
    def email_spam(self) -> bool:
        """Gets the email_spam of this IPBlocklistDetails.  # noqa: E501

        IP address was part of a known email spam attack (SMTP).  # noqa: E501

        :return: The email_spam of this IPBlocklistDetails.  # noqa: E501
        """
        return self._email_spam

    @email_spam.setter
    def email_spam(self, email_spam: bool):
        """Sets the email_spam of this IPBlocklistDetails.

        IP address was part of a known email spam attack (SMTP).  # noqa: E501

        :param email_spam: The email_spam of this IPBlocklistDetails.  # noqa: E501
        """
        if email_spam is None:
            raise ValueError("Invalid value for `email_spam`, must not be `None`")  # noqa: E501

        self._email_spam = email_spam

    @property
    def attack_source(self) -> bool:
        """Gets the attack_source of this IPBlocklistDetails.  # noqa: E501

        IP address was part of a known network attack (SSH/HTTPS).  # noqa: E501

        :return: The attack_source of this IPBlocklistDetails.  # noqa: E501
        """
        return self._attack_source

    @attack_source.setter
    def attack_source(self, attack_source: bool):
        """Sets the attack_source of this IPBlocklistDetails.

        IP address was part of a known network attack (SSH/HTTPS).  # noqa: E501

        :param attack_source: The attack_source of this IPBlocklistDetails.  # noqa: E501
        """
        if attack_source is None:
            raise ValueError("Invalid value for `attack_source`, must not be `None`")  # noqa: E501

        self._attack_source = attack_source

